﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Charge : MonoBehaviour {

    GameObject player;
    bool charging = false;
    public float speed;
    

	// Use this for initialization
	void Start () {
        player = GameObject.Find("hero");
        System.Random r = new System.Random();
        if (r.Next(2) == 0)
            speed = -speed;
    }
	
	// Update is called once per frame
	void Update () {
        if (!charging)
        {
            gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(speed, 0);
            if (IsPlayerNear() && IsPlayerOnSameLine())
            {
                if (speed < 0)
                    speed = -speed * 2;
                charging = true;
                GameObject.Find("JalapenosYeppaAudio").GetComponent<AudioSource>().Play();
            }
        }
        else
        {
            // Create a vector that's from the enemy to the player.
            float chaseX = player.transform.position.x - transform.position.x > 0 ? 1 : -1;
            float savedY = gameObject.GetComponent<Rigidbody2D>().velocity.y;
            gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(chaseX*speed*1.5f, savedY);
        }
	}

    bool IsPlayerOnSameLine()
    {
        if (System.Math.Abs(player.transform.position.y - gameObject.transform.position.y) <= 2f)
            return true;
        return false;
    }

    bool IsPlayerNear()
    {
        if (System.Math.Abs(player.transform.position.x - gameObject.transform.position.x) <= 20f)
            return true;
        return false;
    }

    void OnTriggerEnter2D(Collider2D coll)
    {
        if (coll.tag == "WayPoint")
        {
            if (!charging)
            {
                speed = -speed;
            }
        }
        
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.name == "hero")
        {
            //Esplodi
            Destroy(gameObject);
        }
    }

}
